/*
 * Copyright 2016 - 2022 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#import <Cocoa/Cocoa.h>

#include <ox/std/string.hpp>

#include "filedialog.hpp"

namespace nostalgia::studio {

ox::Result<ox::String> chooseDirectory() noexcept {
	auto panel = [NSOpenPanel openPanel];
	[panel setAllowsMultipleSelection:NO];
	[panel setCanChooseDirectories:YES];
	[panel setCanChooseFiles:NO];
	[panel setFloatingPanel:YES];
	if ([panel runModal] == NSModalResponseOK) {
		const auto url = [panel URL];
		const auto urlStr = [url absoluteString];
		const auto urlCStr = [urlStr UTF8String];
		return ox::String(urlCStr).substr(7);
	}
	return OxError(1);
}

}
